Index: /code/branches/network/bin/def_keybindings.ini
===================================================================
--- /code/branches/network/bin/def_keybindings.ini	(revision 1448)
+++ /code/branches/network/bin/def_keybindings.ini	(revision 1449)
@@ -1,4 +1,4 @@
 [KeyBinder]
-KeyUNASSIGNED=activateConsole
+KeyUNASSIGNED=openConsole
 KeyESCAPE=exit
 Key1=
@@ -13,5 +13,5 @@
 Key0=
 KeyMINUS=
-KeyEQUALS=activateConsole
+KeyEQUALS=openConsole
 KeyBACK=
 KeyTAB=cycleNavigationFocus
@@ -41,5 +41,5 @@
 KeySEMICOLON=
 KeyAPOSTROPHE=
-KeyGRAVE=activateConsole
+KeyGRAVE=openConsole
 KeyLSHIFT=
 KeyBACKSLASH=
@@ -107,5 +107,5 @@
 KeyUNLABELED=
 KeyNEXTTRACK=
-KeyNUMPADENTER=activateConsole
+KeyNUMPADENTER=openConsole
 KeyRCONTROL=
 KeyMUTE=
Index: /code/branches/network/src/core/InputBuffer.h
===================================================================
--- /code/branches/network/src/core/InputBuffer.h	(revision 1448)
+++ /code/branches/network/src/core/InputBuffer.h	(revision 1449)
@@ -66,4 +66,6 @@
             {
                 struct InputBufferListenerTuple newListener = {listener, (void (InputBufferListener::*)())function, true, bOnlySingleInput, false, '\0', KeyCode::Unassigned};
+                *((int*)(&newListener.listener_)) = (int)(listener);
+
                 this->listeners_.insert(this->listeners_.end(), newListener);
             }
@@ -72,4 +74,5 @@
             {
                 struct InputBufferListenerTuple newListener = {listener, (void (InputBufferListener::*)())function, true, bOnlySingleInput, false, '\0', KeyCode::Unassigned};
+                *((int*)(&newListener.listener_)) = (int)(listener);
                 this->listeners_.insert(this->listeners_.end(), newListener);
             }
@@ -79,4 +82,5 @@
             {
                 struct InputBufferListenerTuple newListener = {listener, (void (InputBufferListener::*)())function, false, bOnlySingleInput, false, _char, KeyCode::Unassigned};
+                *((int*)(&newListener.listener_)) = (int)(listener);
                 this->listeners_.insert(this->listeners_.end(), newListener);
             }
@@ -85,4 +89,5 @@
             {
                 struct InputBufferListenerTuple newListener = {listener, (void (InputBufferListener::*)())function, false, bOnlySingleInput, false, _char, KeyCode::Unassigned};
+                *((int*)(&newListener.listener_)) = (int)(listener);
                 this->listeners_.insert(this->listeners_.end(), newListener);
             }
@@ -92,4 +97,5 @@
             {
                 struct InputBufferListenerTuple newListener = {listener, (void (InputBufferListener::*)())function, false, true, true, '\0', key};
+                *((int*)(&newListener.listener_)) = (int)(listener);
                 this->listeners_.insert(this->listeners_.end(), newListener);
             }
@@ -98,4 +104,5 @@
             {
                 struct InputBufferListenerTuple newListener = {listener, (void (InputBufferListener::*)())function, false, true, true, '\0', key};
+                *((int*)(&newListener.listener_)) = (int)(listener);
                 this->listeners_.insert(this->listeners_.end(), newListener);
             }
Index: /code/branches/network/src/core/Shell.cc
===================================================================
--- /code/branches/network/src/core/Shell.cc	(revision 1448)
+++ /code/branches/network/src/core/Shell.cc	(revision 1449)
@@ -102,4 +102,5 @@
         {
             this->inputBuffer_->unregisterListener(this);
+            // TODO: may be very dangerous. InputManager already deletes InputBuffer instance!!!
             delete this->inputBuffer_;
         }
Index: /code/branches/network/visual_studio/vc8/core.vcproj
===================================================================
--- /code/branches/network/visual_studio/vc8/core.vcproj	(revision 1448)
+++ /code/branches/network/visual_studio/vc8/core.vcproj	(revision 1449)
@@ -149,4 +149,8 @@
 			>
 			<File
+				RelativePath="..\..\src\core\ArgumentCompletionFunctions.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\BaseObject.cc"
 				>
@@ -157,4 +161,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\CommandEvaluation.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\CommandExecutor.cc"
 				>
@@ -169,4 +177,12 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\ConsoleCommand.cc"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\core\ConsoleCommandCompilation.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\CoreSettings.cc"
 				>
@@ -201,4 +217,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\IRC.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\KeyBinder.cc"
 				>
@@ -229,4 +249,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\OutputBuffer.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\OutputHandler.cc"
 				>
@@ -237,4 +261,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\Shell.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\SignalHandler.cc"
 				>
@@ -242,4 +270,8 @@
 			<File
 				RelativePath="..\..\src\core\TclBind.cc"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\core\TclThreadManager.cc"
 				>
 			</File>
@@ -267,4 +299,16 @@
 			>
 			<File
+				RelativePath="..\..\src\core\ArgumentCompleter.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\core\ArgumentCompletionFunctions.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\core\ArgumentCompletionListElement.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\BaseObject.h"
 				>
@@ -283,4 +327,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\CommandEvaluation.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\CommandExecutor.h"
 				>
@@ -303,4 +351,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\ConsoleCommandCompilation.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\CoreIncludes.h"
 				>
@@ -355,4 +407,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\IRC.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\Iterator.h"
 				>
@@ -395,4 +451,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\OutputBuffer.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\OutputHandler.h"
 				>
@@ -403,4 +463,12 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\Script_clean.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\core\Shell.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\SignalHandler.h"
 				>
@@ -408,4 +476,8 @@
 			<File
 				RelativePath="..\..\src\core\TclBind.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\core\TclThreadManager.h"
 				>
 			</File>