Index: /code/branches/network/src/core/OutputHandler.cc
===================================================================
--- /code/branches/network/src/core/OutputHandler.cc	(revision 1451)
+++ /code/branches/network/src/core/OutputHandler.cc	(revision 1452)
@@ -35,4 +35,5 @@
 #include "CoreSettings.h"
 #include "ConsoleCommand.h"
+#include "Shell.h"
 
 namespace orxonox
@@ -83,4 +84,14 @@
     {
         return CoreSettings::getSoftDebugLevel(device);
+    }
+
+    /**
+        @brief Returns the Shell's OutputBuffer. This is mere placed here to avoid
+               recompiling the entire project when Shell.h changes.
+        @return The OutputBuffer of the Shell
+    */
+    OutputBuffer& OutputHandler::getShellOutputBuffer()
+    {
+        return Shell::getInstance().getOutputBuffer();
     }
 
Index: /code/branches/network/src/core/OutputHandler.h
===================================================================
--- /code/branches/network/src/core/OutputHandler.h	(revision 1451)
+++ /code/branches/network/src/core/OutputHandler.h	(revision 1452)
@@ -44,5 +44,5 @@
 #include <string>
 
-#include "Shell.h"
+#include "OutputBuffer.h"
 
 namespace orxonox
@@ -95,4 +95,6 @@
 
             static int getSoftDebugLevel(OutputHandler::OutputDevice device);
+
+            OutputBuffer& getShellOutputBuffer();
 
             template <class T>
@@ -157,5 +159,5 @@
 
         if (OutputHandler::getSoftDebugLevel(OutputHandler::LD_Shell) >= this->outputLevel_)
-            Shell::getInstance().getOutputBuffer() << output;
+            OutputHandler::getOutStream().getShellOutputBuffer() << output;
 
         return *this;
@@ -181,5 +183,5 @@
 
         if (OutputHandler::getSoftDebugLevel(OutputHandler::LD_Shell) >= out.getOutputLevel())
-            Shell::getInstance().getOutputBuffer() << output;
+            OutputHandler::getOutStream().getShellOutputBuffer() << output;
 
         return out;
Index: /code/branches/network/visual_studio/vc8/core.vcproj
===================================================================
--- /code/branches/network/visual_studio/vc8/core.vcproj	(revision 1451)
+++ /code/branches/network/visual_studio/vc8/core.vcproj	(revision 1452)
@@ -149,24 +149,4 @@
 			>
 			<File
-				RelativePath="..\..\src\core\ArgumentCompletionFunctions.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\BaseObject.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\ClassTreeMask.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\CommandEvaluation.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\CommandExecutor.cc"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\ConfigFileManager.cc"
 				>
@@ -177,12 +157,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\ConsoleCommand.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\ConsoleCommandCompilation.cc"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\CoreSettings.cc"
 				>
@@ -193,56 +165,8 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\Executor.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\Factory.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\Identifier.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\IdentifierDistributor.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\InputBuffer.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\InputManager.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\IRC.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\KeyBinder.cc"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\Language.cc"
 				>
 			</File>
 			<File
-				RelativePath="..\..\src\core\Loader.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\MetaObjectList.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\Namespace.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\NamespaceNode.cc"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\OrxonoxClass.cc"
 				>
@@ -261,27 +185,11 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\Shell.cc"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\SignalHandler.cc"
 				>
 			</File>
 			<File
-				RelativePath="..\..\src\core\TclBind.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\TclThreadManager.cc"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\Tickable.cc"
 				>
 			</File>
-			<File
-				RelativePath="..\..\src\core\XMLPort.cc"
-				>
-			</File>
 			<Filter
 				Name="tolua"
@@ -289,4 +197,116 @@
 				<File
 					RelativePath="..\..\src\core\tolua\tolua_bind.cc"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="command"
+				>
+				<File
+					RelativePath="..\..\src\core\ArgumentCompletionFunctions.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\CommandEvaluation.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\CommandExecutor.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\ConsoleCommand.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\ConsoleCommandCompilation.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Executor.cc"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="hierarchy"
+				>
+				<File
+					RelativePath="..\..\src\core\Factory.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Identifier.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\IdentifierDistributor.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\MetaObjectList.cc"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="level"
+				>
+				<File
+					RelativePath="..\..\src\core\BaseObject.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\ClassTreeMask.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Loader.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Namespace.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\NamespaceNode.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\XMLPort.cc"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="input"
+				>
+				<File
+					RelativePath="..\..\src\core\InputBuffer.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\InputManager.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\KeyBinder.cc"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="shell"
+				>
+				<File
+					RelativePath="..\..\src\core\IRC.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Shell.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\TclBind.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\TclThreadManager.cc"
 					>
 				</File>
@@ -299,40 +319,4 @@
 			>
 			<File
-				RelativePath="..\..\src\core\ArgumentCompleter.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\ArgumentCompletionFunctions.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\ArgumentCompletionListElement.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\BaseObject.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\ClassFactory.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\ClassManager.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\ClassTreeMask.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\CommandEvaluation.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\CommandExecutor.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\ConfigFileManager.h"
 				>
@@ -347,16 +331,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\ConsoleCommand.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\ConsoleCommandCompilation.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\CoreIncludes.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\CorePrereqs.h"
 				>
@@ -375,76 +347,8 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\Executor.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\Factory.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\Functor.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\Identifier.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\IdentifierDistributor.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\InputBuffer.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\InputInterfaces.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\InputManager.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\IRC.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\Iterator.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\KeyBinder.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\Language.h"
 				>
 			</File>
 			<File
-				RelativePath="..\..\src\core\Level.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\Loader.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\MetaObjectList.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\Namespace.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\NamespaceNode.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\ObjectList.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\OrxonoxClass.h"
 				>
@@ -467,27 +371,163 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\Shell.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\SignalHandler.h"
 				>
 			</File>
 			<File
-				RelativePath="..\..\src\core\TclBind.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\TclThreadManager.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\Tickable.h"
 				>
 			</File>
-			<File
-				RelativePath="..\..\src\core\XMLPort.h"
-				>
-			</File>
+			<Filter
+				Name="input"
+				>
+				<File
+					RelativePath="..\..\src\core\InputBuffer.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\InputInterfaces.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\InputManager.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\KeyBinder.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="command"
+				>
+				<File
+					RelativePath="..\..\src\core\ArgumentCompleter.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\ArgumentCompletionFunctions.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\ArgumentCompletionListElement.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\CommandEvaluation.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\CommandExecutor.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\ConsoleCommand.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\ConsoleCommandCompilation.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Executor.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Functor.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="shell"
+				>
+				<File
+					RelativePath="..\..\src\core\IRC.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Shell.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\TclBind.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\TclThreadManager.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="hierarchy"
+				>
+				<File
+					RelativePath="..\..\src\core\ClassFactory.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\ClassManager.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\CoreIncludes.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Factory.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Identifier.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\IdentifierDistributor.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Iterator.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\MetaObjectList.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\ObjectList.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="level"
+				>
+				<File
+					RelativePath="..\..\src\core\BaseObject.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\ClassTreeMask.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Level.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Loader.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Namespace.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\NamespaceNode.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\XMLPort.h"
+					>
+				</File>
+			</Filter>
 			<Filter
 				Name="tolua"