Index: code/branches/network/src/core/InputBuffer.h
===================================================================
--- code/branches/network/src/core/InputBuffer.h	(revision 1460)
+++ code/branches/network/src/core/InputBuffer.h	(revision 1461)
@@ -66,4 +66,6 @@
             {
                 struct InputBufferListenerTuple newListener = {listener, (void (InputBufferListener::*)())function, true, bOnlySingleInput, false, '\0', KeyCode::Unassigned};
+                // TODO: this is a major hack!!!
+                // Fix it properly
                 *((int*)(&newListener.listener_)) = (int)(listener);
 
Index: code/branches/network/src/core/InputManager.cc
===================================================================
--- code/branches/network/src/core/InputManager.cc	(revision 1460)
+++ code/branches/network/src/core/InputManager.cc	(revision 1461)
@@ -573,5 +573,5 @@
             marginalsMin_[i] = INT_MAX;
           }
-          COUT(3) << "Move all joy stick axes in all directions a few times. "
+          COUT(1) << "Move all joy stick axes in all directions a few times. "
             << "Then put all axes in zero state and hit enter." << std::endl;
 
@@ -598,4 +598,5 @@
         _completeCalibration();
         _restoreState();
+        keyBinder_->resetJoyStickAxes();
         state_ = IS_NOCALIBRATE;
         stateRequest_ = savedState_;
@@ -1121,6 +1122,6 @@
   {
     setInputState(IS_NODETECT);
-    COUT(3) << "Binding string \"" << bindingCommmandString_s << "\" on key '" << name << "'" << std::endl;
-    CommandExecutor::execute("set KeyBinder " + name + " " + bindingCommmandString_s, false);
+    COUT(1) << "Binding string \"" << bindingCommmandString_s << "\" on key '" << name << "'" << std::endl;
+    CommandExecutor::execute("config KeyBinder " + name + " " + bindingCommmandString_s, false);
   }
 
@@ -1129,5 +1130,5 @@
     bindingCommmandString_s = command;
     setInputState(IS_DETECT);
-    COUT(3) << "Press any button/key or move a mouse/joystick axis" << std::endl;
+    COUT(1) << "Press any button/key or move a mouse/joystick axis" << std::endl;
   }
 
Index: code/branches/network/src/core/KeyBinder.cc
===================================================================
--- code/branches/network/src/core/KeyBinder.cc	(revision 1460)
+++ code/branches/network/src/core/KeyBinder.cc	(revision 1461)
@@ -621,4 +621,13 @@
   }
 
+  void KeyBinder::resetJoyStickAxes()
+  {
+    for (unsigned int i = 8; i < nHalfAxes_s; i++)
+    {
+      halfAxes_[i].absVal_ = 0.0f;
+      halfAxes_[i].relVal_ = 0.0f;
+    }
+  }
+
   void KeyBinder::tickInput(float dt, const HandlerState& state)
   {
Index: code/branches/network/src/core/KeyBinder.h
===================================================================
--- code/branches/network/src/core/KeyBinder.h	(revision 1460)
+++ code/branches/network/src/core/KeyBinder.h	(revision 1461)
@@ -146,4 +146,5 @@
     void clearBindings();
     void setConfigValues();
+    void resetJoyStickAxes();
 
   protected: // functions
Index: code/branches/network/src/cpptcl/CppTcl.cc
===================================================================
--- code/branches/network/src/cpptcl/CppTcl.cc	(revision 1460)
+++ code/branches/network/src/cpptcl/CppTcl.cc	(revision 1461)
@@ -953,4 +953,6 @@
 
      {
+          // TODO: why could this probably be necessary? map::find of empty map
+          // shouldn't be a problem.
           if (callbacks.size() == 0)
             return;
Index: code/branches/network/src/orxonox/hud/HUD.cc
===================================================================
--- code/branches/network/src/orxonox/hud/HUD.cc	(revision 1460)
+++ code/branches/network/src/orxonox/hud/HUD.cc	(revision 1461)
@@ -213,11 +213,9 @@
 
     /*static*/ void HUD::toggleFPS(){
-        if(HUD::getSingleton().showFPS) HUD::getSingleton().showFPS = false;
-        else HUD::getSingleton().showFPS = true;
+        HUD::getSingleton().showFPS = !HUD::getSingleton().showFPS;
     }
 
     /*static*/ void HUD::toggleRenderTime(){
-        if(HUD::getSingleton().showRenderTime) HUD::getSingleton().showRenderTime = false;
-        else HUD::getSingleton().showRenderTime = true;
+        HUD::getSingleton().showRenderTime = !HUD::getSingleton().showRenderTime;
     }
 }