Index: code/branches/network/src/orxonox/GraphicsEngine.cc
===================================================================
--- code/branches/network/src/orxonox/GraphicsEngine.cc	(revision 1465)
+++ code/branches/network/src/orxonox/GraphicsEngine.cc	(revision 1466)
@@ -48,6 +48,15 @@
 #include "console/InGameConsole.h"
 
+#include "core/ConsoleCommand.h"
+#include <OgreSceneManager.h>
+#include <OgreCompositorManager.h>
+#include <OgreViewport.h>
+
 namespace orxonox {
-
+  
+  SetConsoleCommandShortcut(GraphicsEngine, CompositorBloomOn).setAccessLevel(AccessLevel::User);
+  SetConsoleCommandShortcut(GraphicsEngine, CompositorMotionBlurOn).setAccessLevel(AccessLevel::User);
+  SetConsoleCommandShortcut(GraphicsEngine, CompositorBloomOff).setAccessLevel(AccessLevel::User);
+  SetConsoleCommandShortcut(GraphicsEngine, CompositorMotionBlurOff).setAccessLevel(AccessLevel::User);
   /**
     @brief Returns the singleton instance and creates it the first time.
@@ -369,3 +378,32 @@
     CommandExecutor::execute("exit", false);
   }
+
+  //HACK!!
+  void GraphicsEngine::CompositorBloomOn()
+  {
+    Ogre::SceneManager* mSceneMgr = GraphicsEngine::getSingleton().getSceneManager();
+    Ogre::Viewport* mViewport = mSceneMgr->getCurrentViewport();
+    Ogre::CompositorManager::getSingleton().addCompositor(mViewport, "Bloom");
+    Ogre::CompositorManager::getSingleton().setCompositorEnabled(mViewport, "Bloom", true);
+  }
+  void GraphicsEngine::CompositorBloomOff()
+  {
+    Ogre::SceneManager* mSceneMgr = GraphicsEngine::getSingleton().getSceneManager();
+    Ogre::Viewport* mViewport = mSceneMgr->getCurrentViewport();
+    Ogre::CompositorManager::getSingleton().setCompositorEnabled(mViewport, "Bloom", false);
+  }
+
+  void GraphicsEngine::CompositorMotionBlurOn()
+  {
+    Ogre::SceneManager* mSceneMgr = GraphicsEngine::getSingleton().getSceneManager();
+    Ogre::Viewport* mViewport = mSceneMgr->getCurrentViewport();
+    Ogre::CompositorManager::getSingleton().addCompositor(mViewport, "MotionBlur");
+    Ogre::CompositorManager::getSingleton().setCompositorEnabled(mViewport, "MotionBlur", true);
+  }
+  void GraphicsEngine::CompositorMotionBlurOff()
+  {
+    Ogre::SceneManager* mSceneMgr = GraphicsEngine::getSingleton().getSceneManager();
+    Ogre::Viewport* mViewport = mSceneMgr->getCurrentViewport();
+    Ogre::CompositorManager::getSingleton().setCompositorEnabled(mViewport, "MotionBlur", false);
+  }
 }
Index: code/branches/network/src/orxonox/GraphicsEngine.h
===================================================================
--- code/branches/network/src/orxonox/GraphicsEngine.h	(revision 1465)
+++ code/branches/network/src/orxonox/GraphicsEngine.h	(revision 1466)
@@ -83,4 +83,11 @@
             static GraphicsEngine* getSingletonPtr() { return &getSingleton(); }
 
+            //HACK!!!
+            void static CompositorBloomOn();
+            void static CompositorBloomOff();
+            void static CompositorMotionBlurOn();
+            void static CompositorMotionBlurOff();
+
+
         private:
             // don't mess with singletons
Index: code/branches/network/src/orxonox/Orxonox.cc
===================================================================
--- code/branches/network/src/orxonox/Orxonox.cc	(revision 1465)
+++ code/branches/network/src/orxonox/Orxonox.cc	(revision 1466)
@@ -70,4 +70,7 @@
 // objects and tools
 #include "hud/HUD.h"
+#include <Ogre.h>
+
+#include "GraphicsEngine.h"
 
 // FIXME: is this really file scope?
@@ -340,5 +343,15 @@
     Level* startlevel = new Level("levels/sample.oxw");
     Loader::open(startlevel);
-
+    
+
+    Ogre::SceneManager* mSceneMgr = GraphicsEngine::getSingleton().getSceneManager();
+    mSceneMgr->setAmbientLight(ColourValue(0.4,0.4,0.4));
+    Ogre::Light* dirlight = mSceneMgr->createLight("Light1");
+
+       dirlight->setType(Ogre::Light::LT_DIRECTIONAL);
+       dirlight->setDirection(Vector3( 0, 1, 5 ));
+       dirlight->setDiffuseColour(ColourValue(0.6, 0.6, 0.4));
+       dirlight->setSpecularColour(ColourValue(1.0, 1.0, 1.0));
+    
     return true;
   }
@@ -380,4 +393,10 @@
     clock_t time = 0;
 
+    //Ogre::SceneManager* mSceneMgr = GraphicsEngine::getSingleton().getSceneManager();
+    //Ogre::Viewport* mViewport = mSceneMgr->getCurrentViewport();
+    
+    //Ogre::CompositorManager::getSingleton().addCompositor(mViewport, "Bloom");
+    //Ogre::CompositorManager::getSingleton().addCompositor(mViewport, "MotionBlur");
+
     COUT(3) << "Orxonox: Starting the main loop." << std::endl;
 	  while (!bAbort_)
Index: code/branches/network/src/orxonox/objects/Model.cc
===================================================================
--- code/branches/network/src/orxonox/objects/Model.cc	(revision 1465)
+++ code/branches/network/src/orxonox/objects/Model.cc	(revision 1466)
@@ -34,4 +34,10 @@
 #include "GraphicsEngine.h"
 #include "core/XMLPort.h"
+
+#include <OgreEntity.h>
+#include <OgreMesh.h>
+#include <OgreHardwareVertexBuffer.h>
+#include <OgreMeshManager.h>
+
 
 namespace orxonox
@@ -77,4 +83,26 @@
         this->mesh_.setMesh(meshSrc_);
         this->attachObject(this->mesh_.getEntity());
+
+        //HACK!!
+        if ((this->meshSrc_ == "assff.mesh") || (this->meshSrc_ == "ast1.mesh") || (this->meshSrc_ == "ast2.mesh") || (this->meshSrc_ == "ast3.mesh") || (this->meshSrc_ == "ast4.mesh") ||(this->meshSrc_ == "ast5.mesh") || (this->meshSrc_ == "ast6.mesh"))
+        {
+          Ogre::MeshPtr pMesh = this->mesh_.getEntity()->getMesh();
+          //set Mesh to tangentspace 
+          unsigned short src, dest;
+          if (!pMesh->suggestTangentVectorBuildParams(Ogre::VES_TANGENT, src, dest))
+          {
+            pMesh->buildTangentVectors(Ogre::VES_TANGENT, src, dest);
+          }
+          if ((this->meshSrc_ == "assff.mesh"))
+          {
+            (this->mesh_.getEntity())->setMaterialName("Assff/BumpMap");
+          }
+          else
+          {
+            (this->mesh_.getEntity())->setMaterialName("Asteroid/BumpMap");
+          }
+
+
+        }
         COUT(4) << "Loader (Model.cc): Created model" << std::endl;
       }