Index: /code/branches/network/src/network/ClientConnection.cc
===================================================================
--- /code/branches/network/src/network/ClientConnection.cc	(revision 1491)
+++ /code/branches/network/src/network/ClientConnection.cc	(revision 1492)
@@ -133,19 +133,10 @@
   }
 
-//   bool ClientConnection::sendPackets(ENetEvent *event) {
-//     if(server==NULL)
-//       return false;
-//     if(enet_host_service(client, event, NETWORK_SEND_WAIT)>=0){
-//       return true;}
-//     else
-//       return false;
-//   }
-
   bool ClientConnection::sendPackets() {
-    ENetEvent event;
     if(server==NULL)
       return false;
     boost::recursive_mutex::scoped_lock lock(enet_mutex_);
     enet_host_flush(client);
+    lock.unlock();
     return true;
   }
@@ -159,4 +150,5 @@
       enet_initialize();
       client = enet_host_create(NULL, NETWORK_CLIENT_MAX_CONNECTIONS, 0, 0);
+      lock.unlock();
     }
     if(client==NULL) {
@@ -183,4 +175,5 @@
           // add some error handling here ========================
         }
+        lock.unlock();
       }
       switch(event->type){
@@ -201,5 +194,5 @@
         continue;
       }
-      //receiverThread_->yield();
+      receiverThread_->yield();
     }
     // now disconnect
Index: /code/branches/network/src/network/ClientConnection.h
===================================================================
--- /code/branches/network/src/network/ClientConnection.h	(revision 1491)
+++ /code/branches/network/src/network/ClientConnection.h	(revision 1492)
@@ -54,6 +54,5 @@
 #define NETWORK_PORT 55556
 #define NETWORK_CLIENT_MAX_CONNECTIONS 5
-#define NETWORK_CLIENT_TIMEOUT 1000
-#define NETWORK_SEND_WAIT 500
+#define NETWORK_CLIENT_TIMEOUT 10
 #define NETWORK_CLIENT_CHANNELS 2
 
Index: /code/branches/network/src/network/ConnectionManager.cc
===================================================================
--- /code/branches/network/src/network/ConnectionManager.cc	(revision 1491)
+++ /code/branches/network/src/network/ConnectionManager.cc	(revision 1492)
@@ -169,13 +169,4 @@
   }
 
-  /*bool ConnectionManager::sendPackets(ENetEvent *event) {
-    if(server==NULL)
-      return false;
-    if(enet_host_service(server, event, NETWORK_SEND_WAIT)>=0)
-      return true;
-    else
-      return false;
-  }*/
-
   bool ConnectionManager::sendPackets() {
     if(server==NULL)
@@ -183,4 +174,5 @@
     boost::recursive_mutex::scoped_lock lock(enet_mutex_);
     enet_host_flush(server);
+    lock.unlock();
     return true;
   }
@@ -194,4 +186,5 @@
       enet_initialize();
       server = enet_host_create(&bindAddress, NETWORK_MAX_CONNECTIONS, 0, 0);
+      lock.unlock();
     }
     if(server==NULL){
@@ -211,4 +204,5 @@
           // add some error handling here ========================
         }
+        lock.unlock();
       }
       switch(event->type){
@@ -235,5 +229,5 @@
         case ENET_EVENT_TYPE_NONE:
           delete event;
-          //receiverThread_->yield();
+          receiverThread_->yield();
           break;
       }
@@ -246,4 +240,5 @@
       boost::recursive_mutex::scoped_lock lock(enet_mutex_);
       enet_host_destroy(server);
+      lock.unlock();
     }
   }
@@ -259,4 +254,5 @@
         boost::recursive_mutex::scoped_lock lock(enet_mutex_);
         enet_peer_disconnect(temp->getPeer(), 0);
+        lock.unlock();
       }
       temp = temp->next();
@@ -439,4 +435,5 @@
       boost::recursive_mutex::scoped_lock lock(enet_mutex_);
       enet_peer_disconnect(client->getPeer(), 0);
+      lock.unlock();
     }
     removeShip(client);
Index: /code/branches/network/src/network/ConnectionManager.h
===================================================================
--- /code/branches/network/src/network/ConnectionManager.h	(revision 1491)
+++ /code/branches/network/src/network/ConnectionManager.h	(revision 1492)
@@ -62,6 +62,5 @@
 #define NETWORK_PORT 55556
 #define NETWORK_MAX_CONNECTIONS 50
-#define NETWORK_WAIT_TIMEOUT 5000
-#define NETWORK_SEND_WAIT 5
+#define NETWORK_WAIT_TIMEOUT 10
 
   struct ClientList{